import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface RulesetRuleConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#disabled RulesetRule#disabled}.
     *
     * @stability stable
     */
    readonly disabled?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#position RulesetRule#position}.
     *
     * @stability stable
     */
    readonly position?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#ruleset RulesetRule#ruleset}.
     *
     * @stability stable
     */
    readonly ruleset: string;
    /**
     * actions block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#actions RulesetRule#actions}
     *
     * @stability stable
     */
    readonly actions?: RulesetRuleActions[];
    /**
     * conditions block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#conditions RulesetRule#conditions}
     *
     * @stability stable
     */
    readonly conditions?: RulesetRuleConditions[];
    /**
     * time_frame block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#time_frame RulesetRule#time_frame}
     *
     * @stability stable
     */
    readonly timeFrame?: RulesetRuleTimeFrame[];
    /**
     * variable block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#variable RulesetRule#variable}
     *
     * @stability stable
     */
    readonly variable?: RulesetRuleVariable[];
}
/**
 * @stability stable
 */
export interface RulesetRuleActionsAnnotate {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#value RulesetRule#value}.
     *
     * @stability stable
     */
    readonly value?: string;
}
/**
 * @stability stable
 */
export interface RulesetRuleActionsEventAction {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#value RulesetRule#value}.
     *
     * @stability stable
     */
    readonly value?: string;
}
/**
 * @stability stable
 */
export interface RulesetRuleActionsExtractions {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#regex RulesetRule#regex}.
     *
     * @stability stable
     */
    readonly regex?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#source RulesetRule#source}.
     *
     * @stability stable
     */
    readonly source?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#target RulesetRule#target}.
     *
     * @stability stable
     */
    readonly target?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#template RulesetRule#template}.
     *
     * @stability stable
     */
    readonly template?: string;
}
/**
 * @stability stable
 */
export interface RulesetRuleActionsPriority {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#value RulesetRule#value}.
     *
     * @stability stable
     */
    readonly value?: string;
}
/**
 * @stability stable
 */
export interface RulesetRuleActionsRoute {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#value RulesetRule#value}.
     *
     * @stability stable
     */
    readonly value?: string;
}
/**
 * @stability stable
 */
export interface RulesetRuleActionsSeverity {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#value RulesetRule#value}.
     *
     * @stability stable
     */
    readonly value?: string;
}
/**
 * @stability stable
 */
export interface RulesetRuleActionsSuppress {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#threshold_time_amount RulesetRule#threshold_time_amount}.
     *
     * @stability stable
     */
    readonly thresholdTimeAmount?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#threshold_time_unit RulesetRule#threshold_time_unit}.
     *
     * @stability stable
     */
    readonly thresholdTimeUnit?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#threshold_value RulesetRule#threshold_value}.
     *
     * @stability stable
     */
    readonly thresholdValue?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#value RulesetRule#value}.
     *
     * @stability stable
     */
    readonly value?: boolean;
}
/**
 * @stability stable
 */
export interface RulesetRuleActionsSuspend {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#value RulesetRule#value}.
     *
     * @stability stable
     */
    readonly value?: number;
}
/**
 * @stability stable
 */
export interface RulesetRuleActions {
    /**
     * annotate block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#annotate RulesetRule#annotate}
     *
     * @stability stable
     */
    readonly annotate?: RulesetRuleActionsAnnotate[];
    /**
     * event_action block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#event_action RulesetRule#event_action}
     *
     * @stability stable
     */
    readonly eventAction?: RulesetRuleActionsEventAction[];
    /**
     * extractions block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#extractions RulesetRule#extractions}
     *
     * @stability stable
     */
    readonly extractions?: RulesetRuleActionsExtractions[];
    /**
     * priority block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#priority RulesetRule#priority}
     *
     * @stability stable
     */
    readonly priority?: RulesetRuleActionsPriority[];
    /**
     * route block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#route RulesetRule#route}
     *
     * @stability stable
     */
    readonly route?: RulesetRuleActionsRoute[];
    /**
     * severity block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#severity RulesetRule#severity}
     *
     * @stability stable
     */
    readonly severity?: RulesetRuleActionsSeverity[];
    /**
     * suppress block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#suppress RulesetRule#suppress}
     *
     * @stability stable
     */
    readonly suppress?: RulesetRuleActionsSuppress[];
    /**
     * suspend block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#suspend RulesetRule#suspend}
     *
     * @stability stable
     */
    readonly suspend?: RulesetRuleActionsSuspend[];
}
/**
 * @stability stable
 */
export interface RulesetRuleConditionsSubconditionsParameter {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#path RulesetRule#path}.
     *
     * @stability stable
     */
    readonly path?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#value RulesetRule#value}.
     *
     * @stability stable
     */
    readonly value?: string;
}
/**
 * @stability stable
 */
export interface RulesetRuleConditionsSubconditions {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#operator RulesetRule#operator}.
     *
     * @stability stable
     */
    readonly operator?: string;
    /**
     * parameter block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#parameter RulesetRule#parameter}
     *
     * @stability stable
     */
    readonly parameter?: RulesetRuleConditionsSubconditionsParameter[];
}
/**
 * @stability stable
 */
export interface RulesetRuleConditions {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#operator RulesetRule#operator}.
     *
     * @stability stable
     */
    readonly operator?: string;
    /**
     * subconditions block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#subconditions RulesetRule#subconditions}
     *
     * @stability stable
     */
    readonly subconditions?: RulesetRuleConditionsSubconditions[];
}
/**
 * @stability stable
 */
export interface RulesetRuleTimeFrameActiveBetween {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#end_time RulesetRule#end_time}.
     *
     * @stability stable
     */
    readonly endTime?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#start_time RulesetRule#start_time}.
     *
     * @stability stable
     */
    readonly startTime?: number;
}
/**
 * @stability stable
 */
export interface RulesetRuleTimeFrameScheduledWeekly {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#duration RulesetRule#duration}.
     *
     * @stability stable
     */
    readonly duration?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#start_time RulesetRule#start_time}.
     *
     * @stability stable
     */
    readonly startTime?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#timezone RulesetRule#timezone}.
     *
     * @stability stable
     */
    readonly timezone?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#weekdays RulesetRule#weekdays}.
     *
     * @stability stable
     */
    readonly weekdays?: number[];
}
/**
 * @stability stable
 */
export interface RulesetRuleTimeFrame {
    /**
     * active_between block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#active_between RulesetRule#active_between}
     *
     * @stability stable
     */
    readonly activeBetween?: RulesetRuleTimeFrameActiveBetween[];
    /**
     * scheduled_weekly block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#scheduled_weekly RulesetRule#scheduled_weekly}
     *
     * @stability stable
     */
    readonly scheduledWeekly?: RulesetRuleTimeFrameScheduledWeekly[];
}
/**
 * @stability stable
 */
export interface RulesetRuleVariableParameters {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#path RulesetRule#path}.
     *
     * @stability stable
     */
    readonly path?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#value RulesetRule#value}.
     *
     * @stability stable
     */
    readonly value?: string;
}
/**
 * @stability stable
 */
export interface RulesetRuleVariable {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#name RulesetRule#name}.
     *
     * @stability stable
     */
    readonly name?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#type RulesetRule#type}.
     *
     * @stability stable
     */
    readonly type?: string;
    /**
     * parameters block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#parameters RulesetRule#parameters}
     *
     * @stability stable
     */
    readonly parameters?: RulesetRuleVariableParameters[];
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html pagerduty_ruleset_rule}.
 *
 * @stability stable
 */
export declare class RulesetRule extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html pagerduty_ruleset_rule} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: RulesetRuleConfig);
    private _disabled?;
    /**
     * @stability stable
     */
    get disabled(): boolean;
    /**
     * @stability stable
     */
    set disabled(value: boolean);
    /**
     * @stability stable
     */
    resetDisabled(): void;
    /**
     * @stability stable
     */
    get disabledInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _position?;
    /**
     * @stability stable
     */
    get position(): number;
    /**
     * @stability stable
     */
    set position(value: number);
    /**
     * @stability stable
     */
    resetPosition(): void;
    /**
     * @stability stable
     */
    get positionInput(): number | undefined;
    private _ruleset;
    /**
     * @stability stable
     */
    get ruleset(): string;
    /**
     * @stability stable
     */
    set ruleset(value: string);
    /**
     * @stability stable
     */
    get rulesetInput(): string;
    private _actions?;
    /**
     * @stability stable
     */
    get actions(): RulesetRuleActions[];
    /**
     * @stability stable
     */
    set actions(value: RulesetRuleActions[]);
    /**
     * @stability stable
     */
    resetActions(): void;
    /**
     * @stability stable
     */
    get actionsInput(): RulesetRuleActions[] | undefined;
    private _conditions?;
    /**
     * @stability stable
     */
    get conditions(): RulesetRuleConditions[];
    /**
     * @stability stable
     */
    set conditions(value: RulesetRuleConditions[]);
    /**
     * @stability stable
     */
    resetConditions(): void;
    /**
     * @stability stable
     */
    get conditionsInput(): RulesetRuleConditions[] | undefined;
    private _timeFrame?;
    /**
     * @stability stable
     */
    get timeFrame(): RulesetRuleTimeFrame[];
    /**
     * @stability stable
     */
    set timeFrame(value: RulesetRuleTimeFrame[]);
    /**
     * @stability stable
     */
    resetTimeFrame(): void;
    /**
     * @stability stable
     */
    get timeFrameInput(): RulesetRuleTimeFrame[] | undefined;
    private _variable?;
    /**
     * @stability stable
     */
    get variable(): RulesetRuleVariable[];
    /**
     * @stability stable
     */
    set variable(value: RulesetRuleVariable[]);
    /**
     * @stability stable
     */
    resetVariable(): void;
    /**
     * @stability stable
     */
    get variableInput(): RulesetRuleVariable[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
