import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface ServiceEventRuleConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#disabled ServiceEventRule#disabled}.
     *
     * @stability stable
     */
    readonly disabled?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#position ServiceEventRule#position}.
     *
     * @stability stable
     */
    readonly position?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#service ServiceEventRule#service}.
     *
     * @stability stable
     */
    readonly service: string;
    /**
     * actions block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#actions ServiceEventRule#actions}
     *
     * @stability stable
     */
    readonly actions?: ServiceEventRuleActions[];
    /**
     * conditions block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#conditions ServiceEventRule#conditions}
     *
     * @stability stable
     */
    readonly conditions?: ServiceEventRuleConditions[];
    /**
     * time_frame block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#time_frame ServiceEventRule#time_frame}
     *
     * @stability stable
     */
    readonly timeFrame?: ServiceEventRuleTimeFrame[];
    /**
     * variable block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#variable ServiceEventRule#variable}
     *
     * @stability stable
     */
    readonly variable?: ServiceEventRuleVariable[];
}
/**
 * @stability stable
 */
export interface ServiceEventRuleActionsAnnotate {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#value ServiceEventRule#value}.
     *
     * @stability stable
     */
    readonly value?: string;
}
/**
 * @stability stable
 */
export interface ServiceEventRuleActionsEventAction {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#value ServiceEventRule#value}.
     *
     * @stability stable
     */
    readonly value?: string;
}
/**
 * @stability stable
 */
export interface ServiceEventRuleActionsExtractions {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#regex ServiceEventRule#regex}.
     *
     * @stability stable
     */
    readonly regex?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#source ServiceEventRule#source}.
     *
     * @stability stable
     */
    readonly source?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#target ServiceEventRule#target}.
     *
     * @stability stable
     */
    readonly target?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#template ServiceEventRule#template}.
     *
     * @stability stable
     */
    readonly template?: string;
}
/**
 * @stability stable
 */
export interface ServiceEventRuleActionsPriority {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#value ServiceEventRule#value}.
     *
     * @stability stable
     */
    readonly value?: string;
}
/**
 * @stability stable
 */
export interface ServiceEventRuleActionsSeverity {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#value ServiceEventRule#value}.
     *
     * @stability stable
     */
    readonly value?: string;
}
/**
 * @stability stable
 */
export interface ServiceEventRuleActionsSuppress {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#threshold_time_amount ServiceEventRule#threshold_time_amount}.
     *
     * @stability stable
     */
    readonly thresholdTimeAmount?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#threshold_time_unit ServiceEventRule#threshold_time_unit}.
     *
     * @stability stable
     */
    readonly thresholdTimeUnit?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#threshold_value ServiceEventRule#threshold_value}.
     *
     * @stability stable
     */
    readonly thresholdValue?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#value ServiceEventRule#value}.
     *
     * @stability stable
     */
    readonly value?: boolean;
}
/**
 * @stability stable
 */
export interface ServiceEventRuleActionsSuspend {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#value ServiceEventRule#value}.
     *
     * @stability stable
     */
    readonly value?: number;
}
/**
 * @stability stable
 */
export interface ServiceEventRuleActions {
    /**
     * annotate block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#annotate ServiceEventRule#annotate}
     *
     * @stability stable
     */
    readonly annotate?: ServiceEventRuleActionsAnnotate[];
    /**
     * event_action block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#event_action ServiceEventRule#event_action}
     *
     * @stability stable
     */
    readonly eventAction?: ServiceEventRuleActionsEventAction[];
    /**
     * extractions block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#extractions ServiceEventRule#extractions}
     *
     * @stability stable
     */
    readonly extractions?: ServiceEventRuleActionsExtractions[];
    /**
     * priority block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#priority ServiceEventRule#priority}
     *
     * @stability stable
     */
    readonly priority?: ServiceEventRuleActionsPriority[];
    /**
     * severity block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#severity ServiceEventRule#severity}
     *
     * @stability stable
     */
    readonly severity?: ServiceEventRuleActionsSeverity[];
    /**
     * suppress block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#suppress ServiceEventRule#suppress}
     *
     * @stability stable
     */
    readonly suppress?: ServiceEventRuleActionsSuppress[];
    /**
     * suspend block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#suspend ServiceEventRule#suspend}
     *
     * @stability stable
     */
    readonly suspend?: ServiceEventRuleActionsSuspend[];
}
/**
 * @stability stable
 */
export interface ServiceEventRuleConditionsSubconditionsParameter {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#path ServiceEventRule#path}.
     *
     * @stability stable
     */
    readonly path?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#value ServiceEventRule#value}.
     *
     * @stability stable
     */
    readonly value?: string;
}
/**
 * @stability stable
 */
export interface ServiceEventRuleConditionsSubconditions {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#operator ServiceEventRule#operator}.
     *
     * @stability stable
     */
    readonly operator?: string;
    /**
     * parameter block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#parameter ServiceEventRule#parameter}
     *
     * @stability stable
     */
    readonly parameter?: ServiceEventRuleConditionsSubconditionsParameter[];
}
/**
 * @stability stable
 */
export interface ServiceEventRuleConditions {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#operator ServiceEventRule#operator}.
     *
     * @stability stable
     */
    readonly operator?: string;
    /**
     * subconditions block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#subconditions ServiceEventRule#subconditions}
     *
     * @stability stable
     */
    readonly subconditions?: ServiceEventRuleConditionsSubconditions[];
}
/**
 * @stability stable
 */
export interface ServiceEventRuleTimeFrameActiveBetween {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#end_time ServiceEventRule#end_time}.
     *
     * @stability stable
     */
    readonly endTime?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#start_time ServiceEventRule#start_time}.
     *
     * @stability stable
     */
    readonly startTime?: number;
}
/**
 * @stability stable
 */
export interface ServiceEventRuleTimeFrameScheduledWeekly {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#duration ServiceEventRule#duration}.
     *
     * @stability stable
     */
    readonly duration?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#start_time ServiceEventRule#start_time}.
     *
     * @stability stable
     */
    readonly startTime?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#timezone ServiceEventRule#timezone}.
     *
     * @stability stable
     */
    readonly timezone?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#weekdays ServiceEventRule#weekdays}.
     *
     * @stability stable
     */
    readonly weekdays?: number[];
}
/**
 * @stability stable
 */
export interface ServiceEventRuleTimeFrame {
    /**
     * active_between block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#active_between ServiceEventRule#active_between}
     *
     * @stability stable
     */
    readonly activeBetween?: ServiceEventRuleTimeFrameActiveBetween[];
    /**
     * scheduled_weekly block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#scheduled_weekly ServiceEventRule#scheduled_weekly}
     *
     * @stability stable
     */
    readonly scheduledWeekly?: ServiceEventRuleTimeFrameScheduledWeekly[];
}
/**
 * @stability stable
 */
export interface ServiceEventRuleVariableParameters {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#path ServiceEventRule#path}.
     *
     * @stability stable
     */
    readonly path?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#value ServiceEventRule#value}.
     *
     * @stability stable
     */
    readonly value?: string;
}
/**
 * @stability stable
 */
export interface ServiceEventRuleVariable {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#name ServiceEventRule#name}.
     *
     * @stability stable
     */
    readonly name?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#type ServiceEventRule#type}.
     *
     * @stability stable
     */
    readonly type?: string;
    /**
     * parameters block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#parameters ServiceEventRule#parameters}
     *
     * @stability stable
     */
    readonly parameters?: ServiceEventRuleVariableParameters[];
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html pagerduty_service_event_rule}.
 *
 * @stability stable
 */
export declare class ServiceEventRule extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html pagerduty_service_event_rule} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: ServiceEventRuleConfig);
    private _disabled?;
    /**
     * @stability stable
     */
    get disabled(): boolean;
    /**
     * @stability stable
     */
    set disabled(value: boolean);
    /**
     * @stability stable
     */
    resetDisabled(): void;
    /**
     * @stability stable
     */
    get disabledInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _position?;
    /**
     * @stability stable
     */
    get position(): number;
    /**
     * @stability stable
     */
    set position(value: number);
    /**
     * @stability stable
     */
    resetPosition(): void;
    /**
     * @stability stable
     */
    get positionInput(): number | undefined;
    private _service;
    /**
     * @stability stable
     */
    get service(): string;
    /**
     * @stability stable
     */
    set service(value: string);
    /**
     * @stability stable
     */
    get serviceInput(): string;
    private _actions?;
    /**
     * @stability stable
     */
    get actions(): ServiceEventRuleActions[];
    /**
     * @stability stable
     */
    set actions(value: ServiceEventRuleActions[]);
    /**
     * @stability stable
     */
    resetActions(): void;
    /**
     * @stability stable
     */
    get actionsInput(): ServiceEventRuleActions[] | undefined;
    private _conditions?;
    /**
     * @stability stable
     */
    get conditions(): ServiceEventRuleConditions[];
    /**
     * @stability stable
     */
    set conditions(value: ServiceEventRuleConditions[]);
    /**
     * @stability stable
     */
    resetConditions(): void;
    /**
     * @stability stable
     */
    get conditionsInput(): ServiceEventRuleConditions[] | undefined;
    private _timeFrame?;
    /**
     * @stability stable
     */
    get timeFrame(): ServiceEventRuleTimeFrame[];
    /**
     * @stability stable
     */
    set timeFrame(value: ServiceEventRuleTimeFrame[]);
    /**
     * @stability stable
     */
    resetTimeFrame(): void;
    /**
     * @stability stable
     */
    get timeFrameInput(): ServiceEventRuleTimeFrame[] | undefined;
    private _variable?;
    /**
     * @stability stable
     */
    get variable(): ServiceEventRuleVariable[];
    /**
     * @stability stable
     */
    set variable(value: ServiceEventRuleVariable[]);
    /**
     * @stability stable
     */
    resetVariable(): void;
    /**
     * @stability stable
     */
    get variableInput(): ServiceEventRuleVariable[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
